#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include "tos.h"
#include "screen.h"

void vi_putch(unsigned int x, unsigned int y ,char c, char attr);

char hex_tabl[] = "0123456789ABCDEF";

// 뢮   ࠭, न (x,y),
// 뢮 ⭠筮 ।⠢
//  chr  ࠭묨 ਡ⠬ attr.

void vi_put_byte(unsigned int x,
		 unsigned int y, unsigned char chr, char attr)
{
 unsigned char temp;

 temp = hex_tabl[(chr & 0xf0) >> 4];
 vi_putch(x, y, temp, attr);

 temp = hex_tabl[chr & 0xf];
 vi_putch(x+1, y, temp, attr);
}

// 뢮 ᫮  ࠭, न (x,y),
// 뢮 ⭠筮 ।⠢
// ᫮ chr  ࠭묨 ਡ⠬ attr.

void vi_put_word(unsigned int x,
		 unsigned int y, word chr, char attr)
{
 vi_put_byte(x, y, (chr & 0xff00) >> 8, attr);
 vi_put_byte(x+2, y, chr & 0xff, attr);
}

// 뢮 ᨬ c  ࠭, न - (x,y),
// ਡ 뢮 ᨬ - attr

void vi_putch(unsigned int x,
	      unsigned int y ,char c, char attr)
{
 register unsigned int offset;
 char far *vid_ptr;

 offset = (y*160) + (x*2);
 vid_ptr = MK_FP(VID_MEM_SELECTOR, offset);
 *vid_ptr++=c; *vid_ptr=attr;
}

// 뢮 ப s  ࠭, न - (x,y),
// ਡ 뢮 ப - attr

void vi_print(unsigned int x,
	      unsigned int y, char *s, char attr)
{
 while (*s)
  vi_putch(x++, y, *s++, attr);
}

// 뢮 ⮪ ᮮ饭  ᪥ ணࠬ
void vi_hello_msg(void)
{
 vi_print(0, 0,
	  "   Threads for DOS, "
	  "   Version 0.1/i286, Copyright (c) 2000 Eugeny Balahonov    ", 0x30);
}

// 뢮 饩 ப
void StepLabel(TLabel* Label1, TLabel* Label2, char* Buf)
{
 // ࠥ ᨬ ⮪
 Buf[Label1->Pos] = ' ';
 Buf[Label2->Pos] = ' ';

 // ᫨  
 if (Label1->Dir == 0)
 {
  // ᫨  諨  ࠩ  樨
  if (Label1->Pos > 0)
  {
   Label1->Pos--;
   Buf[Label1->Pos] = '\\';
  }
  else
  {
   Label1->Dir = 1;
   Buf[Label1->Pos] = '/';
  }
 }
 // ᫨  ࠢ
 else
 {
  // ᫨  諨  ࠩ ࠢ 樨
  if (Label1->Pos < B_SIZE)
  {
   Label1->Pos++;
   Buf[Label1->Pos] = '/';
  }
  else
  {
   Label1->Dir = 0;
   Buf[Label1->Pos] = '\\';
  }
 }

 // ᫨  
 if (Label2->Dir == 0)
 {
  // ᫨  諨  ࠩ  樨
  if (Label2->Pos > 0)
  {
   Label2->Pos--;
   Buf[Label2->Pos] = '\\';
  }
  else
  {
   Label2->Dir = 1;
   Buf[Label2->Pos] = '/';
  }
 }
 // ᫨  ࠢ
 else
 {
  // ᫨  諨  ࠩ ࠢ 樨
  if (Label2->Pos < B_SIZE)
  {
   Label2->Pos++;
   Buf[Label2->Pos] = '/';
  }
  else
  {
   Label2->Dir = 0;
   Buf[Label2->Pos] = '\\';
  }
 }
}
